/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;

import android.database.Cursor;
import android.text.TextUtils;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.DataConstants;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.gtask.exception.ActionFailureException;
import net.micode.notes.tool.GTaskStringUtils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

/**
 * @Package: net.micode.notes.gtask.data
 * @ClassName:  Task
 * @Description:
 * Task类继承自Node类。该类用于表示一个任务，在Google任务管理系统中使用。
 * 它包含了一些任务的属性和方法，例如任务是否已完成、笔记内容、元数据等。
 * 另外，该类还提供了一些用于生成和解析JSON格式数据的方法，以便与Google任务管理系统进行交互。
 * @Author: Dong Jiaqi
 * @CreateDate: 12/24/2023 19：48 PM
 */
public class Task extends Node {
    private static final String TAG = Task.class.getSimpleName();

    private boolean mCompleted;

    private String mNotes;

    private JSONObject mMetaInfo;

    private Task mPriorSibling;

    private TaskList mParent;

    /**
     * 构造方法在对象创建时被调用，用于初始化对象的属性。
     * 所有属性都被初始化为初始值或者null。
     */
    public Task() {
        super();//调用父类Node的构造方法确保父类的属性得到正确初始化
        mCompleted = false;//任务完成状态设置为未完成
        mNotes = null;//暂时没有便签笔记
        mPriorSibling = null;//当前任务没有前节点
        mParent = null;//当前任务没有父节点
        mMetaInfo = null;//当前任务没有元数据信息
    }

    /**
     * 用于生成一个表示创建任务操作的JSON对象。
     * 如果在生成JSON对象的过程中发生异常，将会抛出一个ActionFailureException异常，并打印错误信息。
     * @param actionId 表示操作的唯一标识符。
     * @return 生成的JSONObject对象，包含了表示创建任务操作的各个字段和对应的值。
     */
    public JSONObject getCreateAction(int actionId) {
        JSONObject js = new JSONObject();//创建一个空的JSONObject对象。

        try {
            // action_type
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_CREATE);

            // action_id
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);

            // index
            js.put(GTaskStringUtils.GTASK_JSON_INDEX, mParent.getChildTaskIndex(this));

            // entity_delta
            JSONObject entity = new JSONObject();
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName());
            entity.put(GTaskStringUtils.GTASK_JSON_CREATOR_ID, "null");
            entity.put(GTaskStringUtils.GTASK_JSON_ENTITY_TYPE,
                    GTaskStringUtils.GTASK_JSON_TYPE_TASK);
            if (getNotes() != null) {
                entity.put(GTaskStringUtils.GTASK_JSON_NOTES, getNotes());
            }
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity);

            // parent_id
            js.put(GTaskStringUtils.GTASK_JSON_PARENT_ID, mParent.getGid());

            // dest_parent_type
            js.put(GTaskStringUtils.GTASK_JSON_DEST_PARENT_TYPE,
                    GTaskStringUtils.GTASK_JSON_TYPE_GROUP);

            // list_id
            js.put(GTaskStringUtils.GTASK_JSON_LIST_ID, mParent.getGid());

            // prior_sibling_id
            if (mPriorSibling != null) {
                js.put(GTaskStringUtils.GTASK_JSON_PRIOR_SIBLING_ID, mPriorSibling.getGid());
            }

        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("fail to generate task-create jsonobject");//抛出异常
        }

        return js;
    }

    /**
     * 用于生成一个表示更新任务操作的JSON对象。
     * @param actionId 表示操作的唯一标识符。
     * @return 生成的JSONObject对象，包含了表示更新任务操作的各个字段和对应的值。
     */
    public JSONObject getUpdateAction(int actionId) {
        JSONObject js = new JSONObject();

        try {
            // action_type
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_UPDATE);

            // action_id
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);

            // id
            js.put(GTaskStringUtils.GTASK_JSON_ID, getGid());

            // entity_delta
            JSONObject entity = new JSONObject();
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName());
            if (getNotes() != null) {
                entity.put(GTaskStringUtils.GTASK_JSON_NOTES, getNotes());
            }
            entity.put(GTaskStringUtils.GTASK_JSON_DELETED, getDeleted());
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity);

        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("fail to generate task-update jsonobject");
        }

        return js;
    }

    /**
     * 用于根据传入的JSONObject对象设置任务的各个字段值。
     * 保持任务对象的状态与传入的JSON数据一致。
     * @param js 表示一个JSONObject对象，包含了任务的各个字段和对应的值。
     */
    public void setContentByRemoteJSON(JSONObject js) {
        if (js != null) {
            try {
                // id
                if (js.has(GTaskStringUtils.GTASK_JSON_ID)) {
                    setGid(js.getString(GTaskStringUtils.GTASK_JSON_ID));
                }

                // last_modified
                if (js.has(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED)) {
                    setLastModified(js.getLong(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED));
                }

                // name
                if (js.has(GTaskStringUtils.GTASK_JSON_NAME)) {
                    setName(js.getString(GTaskStringUtils.GTASK_JSON_NAME));
                }

                // notes
                if (js.has(GTaskStringUtils.GTASK_JSON_NOTES)) {
                    setNotes(js.getString(GTaskStringUtils.GTASK_JSON_NOTES));
                }

                // deleted
                if (js.has(GTaskStringUtils.GTASK_JSON_DELETED)) {
                    setDeleted(js.getBoolean(GTaskStringUtils.GTASK_JSON_DELETED));
                }

                // completed
                if (js.has(GTaskStringUtils.GTASK_JSON_COMPLETED)) {
                    setCompleted(js.getBoolean(GTaskStringUtils.GTASK_JSON_COMPLETED));
                }
            } catch (JSONException e) {
                Log.e(TAG, e.toString());
                e.printStackTrace();
                throw new ActionFailureException("fail to get task content from jsonobject");
            }
        }
    }

    /**
     * 用于根据传入的本地JSONObject对象设置任务的名称，从而与本地数据保持一致。
     * @param js 包含了本地数据的各个字段和对应的值。
     */
    public void setContentByLocalJSON(JSONObject js) {
        if (js == null || !js.has(GTaskStringUtils.META_HEAD_NOTE)
                || !js.has(GTaskStringUtils.META_HEAD_DATA)) {
            Log.w(TAG, "setContentByLocalJSON: nothing is avaiable");
        }

        /**
         * 根据传入的JSONObject对象解析任务的名称字段，并将其设置为任务对象的名称。
         * 同时，还会检查便签的类型，只有当类型为普通便签时才会继续设置任务名称。
         */
        try {
            JSONObject note = js.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
            JSONArray dataArray = js.getJSONArray(GTaskStringUtils.META_HEAD_DATA);

            if (note.getInt(NoteColumns.TYPE) != Notes.TYPE_NOTE) {//检查便签类型是不是普通便签
                Log.e(TAG, "invalid type");
                return;
            }

            for (int i = 0; i < dataArray.length(); i++) {
                JSONObject data = dataArray.getJSONObject(i);
                if (TextUtils.equals(data.getString(DataColumns.MIME_TYPE), DataConstants.NOTE)) {
                    setName(data.getString(DataColumns.CONTENT));
                    break;
                }
            }

        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }
    }

    /**
     * 根据任务对象的内容生成一个本地的JSONObject对象。
     * @return 对于新创建的任务：返回构造好的JSONObject对象js。
     * 对于已同步的任务：返回mMetaInfo对象本身。
     */
    public JSONObject getLocalJSONFromContent() {
        String name = getName();
        try {
            if (mMetaInfo == null) {
                // new task created from web
                if (name == null) {
                    Log.w(TAG, "the note seems to be an empty one");
                    return null;
                }

                JSONObject js = new JSONObject();
                JSONObject note = new JSONObject();
                JSONArray dataArray = new JSONArray();
                JSONObject data = new JSONObject();
                data.put(DataColumns.CONTENT, name);
                dataArray.put(data);
                js.put(GTaskStringUtils.META_HEAD_DATA, dataArray);
                note.put(NoteColumns.TYPE, Notes.TYPE_NOTE);
                js.put(GTaskStringUtils.META_HEAD_NOTE, note);
                return js;
            } else {
                // synced task
                JSONObject note = mMetaInfo.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
                JSONArray dataArray = mMetaInfo.getJSONArray(GTaskStringUtils.META_HEAD_DATA);

                for (int i = 0; i < dataArray.length(); i++) {
                    JSONObject data = dataArray.getJSONObject(i);
                    if (TextUtils.equals(data.getString(DataColumns.MIME_TYPE), DataConstants.NOTE)) {
                        data.put(DataColumns.CONTENT, getName());
                        break;
                    }
                }

                note.put(NoteColumns.TYPE, Notes.TYPE_NOTE);
                return mMetaInfo;
            }
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            return null;
        }
    }

    /**
     * 设置任务的元数据。
     * @param metaData MetaData对象，表示任务的元数据。
     */
    public void setMetaInfo(MetaData metaData) {
        if (metaData != null && metaData.getNotes() != null) {
            try {
                mMetaInfo = new JSONObject(metaData.getNotes());
            } catch (JSONException e) {
                Log.w(TAG, e.toString());
                mMetaInfo = null;
            }
        }
    }

    /**
     * 根据传入的Cursor对象和任务的元数据判断同步操作的类型。
     * @param c Cursor对象c，用于查询本地数据库中的任务数据。
     * @return 整数，表示同步操作的类型
     * SYNC_ACTION_NONE：无需同步
     * SYNC_ACTION_UPDATE_LOCAL：需要更新本地任务
     * SYNC_ACTION_UPDATE_REMOTE：需要更新远程任务
     * SYNC_ACTION_UPDATE_CONFLICT：存在冲突，需要解决
     * SYNC_ACTION_ERROR：同步出错
     */
    public int getSyncAction(Cursor c) {
        try {
            JSONObject noteInfo = null;
            if (mMetaInfo != null && mMetaInfo.has(GTaskStringUtils.META_HEAD_NOTE)) {
                noteInfo = mMetaInfo.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
            }

            if (noteInfo == null) {
                Log.w(TAG, "it seems that note meta has been deleted");
                return SYNC_ACTION_UPDATE_REMOTE;
            }

            if (!noteInfo.has(NoteColumns.ID)) {
                Log.w(TAG, "remote note id seems to be deleted");
                return SYNC_ACTION_UPDATE_LOCAL;
            }

            // validate the note id now
            if (c.getLong(SqlNote.ID_COLUMN) != noteInfo.getLong(NoteColumns.ID)) {
                Log.w(TAG, "note id doesn't match");
                return SYNC_ACTION_UPDATE_LOCAL;
            }

            if (c.getInt(SqlNote.LOCAL_MODIFIED_COLUMN) == 0) {
                // there is no local update
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // no update both side
                    return SYNC_ACTION_NONE;
                } else {
                    // apply remote to local
                    return SYNC_ACTION_UPDATE_LOCAL;
                }
            } else {
                // validate gtask id
                if (!c.getString(SqlNote.GTASK_ID_COLUMN).equals(getGid())) {
                    Log.e(TAG, "gtask id doesn't match");
                    return SYNC_ACTION_ERROR;
                }
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // local modification only
                    return SYNC_ACTION_UPDATE_REMOTE;
                } else {
                    return SYNC_ACTION_UPDATE_CONFLICT;
                }
            }
        } catch (Exception e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }

        return SYNC_ACTION_ERROR;
    }

    /**
     * 判断当前任务是否值得保存。
     * @return 类型为boolean，true表示任务值得保存，false表示任务不值得保存。
     */
    public boolean isWorthSaving() {
        return mMetaInfo != null || (getName() != null && getName().trim().length() > 0)
                || (getNotes() != null && getNotes().trim().length() > 0);
    }

    /**
     * 设置当前任务的完成状态。
     * 调用这个方法，可以更新当前任务的完成状态，以便在应用程序中进行相应的展示或处理。
     * @param completed boolean类型的参数，用来表示当前任务的完成状态。
     */
    public void setCompleted(boolean completed) {
        this.mCompleted = completed;
    }

    /**
     * 设置当前任务的备注信息。
     * 调用这个方法，可以更新当前任务的备注信息，以便在应用程序中进行相应的展示或处理。
     * @param notes String类型的参数，用来表示当前任务的备注信息。
     */
    public void setNotes(String notes) {
        this.mNotes = notes;
    }

    /**
     * 设置当前任务的前一个兄弟任务。
     * 调用这个方法，可以建立任务之间的关联关系，例如设置任务的顺序、父子关系等。
     * @param priorSibling Task类型的参数，表示当前任务的前一个兄弟任务。
     */
    public void setPriorSibling(Task priorSibling) {
        this.mPriorSibling = priorSibling;
    }

    /**
     * 设置当前任务的父任务列表。
     * 调用这个方法，可以建立任务之间的关联关系，例如设置任务的层级结构、父子关系等。
     * @param parent TaskList类型的参数，表示当前任务所属的父任务列表。
     */
    public void setParent(TaskList parent) {
        this.mParent = parent;
    }

    /**
     * 获取当前任务的完成状态。
     * 调用这个方法，可以获取当前任务是否已经完成，以便在应用程序中进行相应的展示或处理。
     * @return 类型为boolean，true表示任务已完成，false表示任务未完成。
     */
    public boolean getCompleted() {
        return this.mCompleted;
    }

    /**
     * 获取当前任务的备注信息。
     * @return 类型为String，表示当前任务的备注信息。如果任务没有备注信息，则返回一个空字符串。
     */
    public String getNotes() {
        return this.mNotes;
    }

    /**
     * 获取当前任务的前一个兄弟任务。
     * @return 类型为Task，表示当前任务的前一个兄弟任务。如果当前任务没有前一个兄弟任务，则返回null。
     */
    public Task getPriorSibling() {
        return this.mPriorSibling;
    }

    /**
     * 获取当前任务所属的父任务列表。
     * @return 类型为TaskList，表示当前任务所属的父任务列表。如果当前任务没有父任务列表，则返回null。
     */
    public TaskList getParent() {
        return this.mParent;
    }

}
